
getArcsWith = function (tok, ns, redlMod) 
{
    df = as(redlMod, "data.frame")
    targ = paste(ns, tok, sep = "")
    nd = grep(targ,as.character(df[,1]))
    nd = union( grep(targ,as.character(df[,2])), nd)
    nd = union( grep(targ,as.character(df[,3])), nd)
    df[nd,]
}


getObjectProperties <- function( redlMod,
  ns="http://www.w3.org/2002/07/owl", strip=TRUE) {
 soln = getArcsWith("#ObjectProperty", ns, redlMod )[, 1]
 if (strip) sort(unique(gsub(".*#", "", as.character(soln))))
 else return(sort(unique(soln)))
}
getDatatypeProperties <- function( redlMod,
  ns="http://www.w3.org/2002/07/owl", strip=TRUE) {
 soln = getArcsWith("#DatatypeProperty", ns, redlMod )[, 1]
 if (strip) sort(unique(gsub(".*#", "", as.character(soln))))
 else return(sort(unique(soln)))
}

getOWLProperties <- function( redlMod,
  ns="http://www.w3.org/2002/07/owl", strip=TRUE) {
  sort(unique(c( getObjectProperties( redlMod, ns, strip ),
     getDatatypeProperties( redlMod, ns, strip ))))
}

getOWLClasses <- function( redlMod,
  ns="http://www.w3.org/2002/07/owl", strip=TRUE) {
 soln = getArcsWith("#Class", ns, redlMod )[, 1]
 if (strip) sort(unique(gsub(".*#", "", as.character(soln))))
 else return(sort(unique(soln)))
}

getPropertyRange <- function( tok, 
    ns, redlMod) {
 stok <- gsub("#","",tok)
 if (!(stok %in% getOWLProperties( redlMod ))) stop(paste(tok, "not in properties of this model"))
 df = getArcsWith( tok, ns, redlMod )
 as.character(df[ df[,2] == "http://www.w3.org/2000/01/rdf-schema#range", 3])
}

getPropertiesWithDomain <- function( tok, 
    ns, redlMod) {
 stok <- gsub("#","",tok)
 if (!(stok %in% getOWLClasses( redlMod ))) stop(paste(tok, "not in classes of this model"))
 df = getArcsWith( tok, ns, redlMod )
 as.character(df[ df[,2] == "http://www.w3.org/2000/01/rdf-schema#domain" &
     as.character(df[,3]) == paste(ns, tok, sep=""), 1])
}

getClassElements <- function( tok, ns, redlMod, strip=TRUE) { 
# allow some special cases for classes that don't have individuals specified
 if (tok == "#numeric") return("numeric")
 if (tok == "#integer") return("integer")
 if (tok == "#string") return("string")
 mat <- getArcsWith( tok, ns, redlMod )
 ans <- mat[ mat[,2] == "http://www.w3.org/1999/02/22-rdf-syntax-ns#type" &
   mat[,3] == paste(ns, tok, sep=""), 1 ]
 if (strip) return(sort(unique(gsub(".*#", "", as.character(ans)))))
 else return(sort(unique(as.character(ans))))
}


getOWLSubclasses = function( of, redlMod,
  ontns,
  owlns="http://www.w3.org/2002/07/owl", strip=TRUE) {
 rdfss = "http://www.w3.org/2000/01/rdf-schema"
 presoln = getArcsWith("#subClassOf", rdfss, redlMod )
 soln = presoln[ presoln[,3] == paste(ontns, of, sep=""), 1]
 if (strip) sort(unique(gsub(".*#", "", as.character(soln))))
 else return(sort(unique(soln)))
}


getClassGraph = function( mod, excl="Codes", 
 ontns, 
 owlns = "http://www.w3.org/2002/07/owl") {
    require(graph)
 allc = getOWLClasses( mod , strip=TRUE )
 cln = NULL
 for (i in 1:length(excl))
    cln = c(cln, grep(excl[i], allc ))
 cln = unique(cln)
 if (length(cln) > 0) allc = allc[-cln]
 pp = function(x) paste("#", x, sep="")
 g = new("graphNEL", nodes=allc, edgemode="directed")
 for (i in 1:length(allc) )
    {
    chil = getOWLSubclasses( pp(allc[i]), mod, ontns, owlns, strip=TRUE )
    cln = NULL
    for (j in 1:length(excl)) cln = c(cln, grep(excl[j], chil))
    if (length(cln)>0) chil = chil[ -cln ]
    if (length(chil) == 0) next
    g = addEdge( allc[i], chil, g, 1 )
    }
 g
}



