\name{redlModel-class}
\docType{class}
\alias{redlModel-class}
\alias{redlURI-class}
\alias{coerce,redlModel,data.frame-method}
\alias{coerce,redlModel,graphNEL-method}
\alias{freeRedl,redlModel-method}
\alias{getStatus,redlModel-method}
\alias{ref,redlModel-method}
\alias{setStatus,redlModel-method}
\alias{show,redlModel-method}
\alias{size,redlModel-method}
\alias{makeRedlURI,character,missing-method}
\alias{ref,redlURI-method}
\alias{show,redlURI-method}
\alias{getStatus}
\alias{setStatus}
\alias{size}
\alias{freeRedl}
\alias{ref}
\alias{nodeFromURIString}
\alias{world}
\alias{redlNode-class}
\alias{show,redlNode-method}
\alias{world,redlNode-method}
\alias{ref,redlNode-method}

\title{Class "redlModel" represents librdf model in Redland RDF library }
\description{represents librdf model in Redland RDF library	}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("redlModel", ...)}.
They encapsulate the reference to the librdf model object in Redland RDF library.
}
\section{Slots}{
	 \describe{
    \item{\code{ref}:}{Object of class \code{"externalptr"} pointer to
malloc'd model space. }
    \item{\code{storagetype}:}{Object of class \code{"character"} can
be "bdb" or "internal" }
    \item{\code{stateEnv}:}{Object of class \code{"environment"} used
to indicate whether model is open or not }
    \item{\code{world}:}{Object of class \code{"redlWorld"}, the world
object in which the model or URI was constructed  }
    \item{\code{URIstring}:}{(for redlURI: string in use as URI }
  }
}
\section{Methods}{
  \describe{
    \item{coerce}{\code{signature(from = "redlModel", to = "data.frame")}: 
 simple transformation to 3-column dataframe (subject, predicate, object) }
    \item{coerce}{\code{signature(from = "redlModel", to = "graphNEL")}: ... }
    \item{freeRedl}{\code{signature(x = "redlModel")}: call
the librdf close method; kills the model. }
    \item{getStatus}{\code{signature(x = "redlModel")}: determine if
a model object is open from the perspective of R }
    \item{ref}{\code{signature(x = "redlModel")}: extract the
externalptr }
    \item{setStatus}{\code{signature(x = "redlModel")}: set a
status flag in the R container for the model object}
    \item{show}{\code{signature(object = "redlModel")}: simple report  }
    \item{size}{\code{signature(x = "redlModel")}: tell the number
of statements in the model }
	 }
}
%\references{ ~put references to the literature/web site here ~ }
\author{ VJ Carey <stvjc@channing.harvard.edu> }
%\note{ ~~further notes~~ }

% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\link{CLASSNAME-class}} for links to other classes
%}
\examples{
example(makeRedlURI)
x = readRDF( uu )
ref(x)
size(x)
getStatus(x)
freeRedl(x)
getStatus(x)
x
}
\keyword{classes}
